#!/perl/bin/perl
$| = 1;
#
#  Copyright 1997 Yukinori Koike  Ver 1.5
#
#
# Check number of parameter
#
if ( $#ARGV == 0 )
{
	#
	# For SSI
	#
	$LOGFILE = @ARGV[0];
}
else
{
	#
	# For CGI
	#
	$str = $ENV{'QUERY_STRING'};
	@part = split('&',$str);
	foreach $pair (@part)
	{
        	($variable,$value) = split('=',$pair);
        	if ( $variable eq "log" )
		{
			$LOGFILE = $value;
		}
		elsif ( $variable eq "prev" || $variable eq "PREV" )
		{
			$PREV = $value;
		}
	}
}
# DATE
@bdate = localtime;
$rec = sprintf("{+}\n{BDATE:20%02d%02d%02d%02d%02d%02d}\n",substr(@bdate[5],1),@bdate[4]+1,@bdate[3],@bdate[2],@bdate[1],@bdate[0]);
# HOST
if ($ENV{'REMOTE_HOST'})
{
        $host = sprintf("{HOST:%s}\n",$ENV{'REMOTE_HOST'});
        $rec = sprintf("%s%s",$rec,$host);
}
# IP
if ($ENV{'REMOTE_ADDR'})
{
        $ip = sprintf("{IP:%s}\n",$ENV{'REMOTE_ADDR'});
        $rec = sprintf("%s%s",$rec,$ip);
}
# BROWSER
if ($ENV{'HTTP_USER_AGENT'})
{
        $browser = sprintf("{BROWSER:%s}\n",$ENV{'HTTP_USER_AGENT'});
        $rec = sprintf("%s%s",$rec,$browser);
}
# PREVIOUS ADDR
if ( $PREV )
{
        $prev_url = sprintf("{URL:%s}",$PREV);
        $rec = sprintf("%s%s",$rec,$prev_url);
}
elsif ($ENV{'HTTP_REFERER'})
{
        $prev_url = sprintf("{URL:%s}",$ENV{'HTTP_REFERER'});
        $rec = sprintf("%s%s",$rec,$prev_url);
}
# Lock FIle
$LOCKFILE = $LOGFILE;
$LOCKFILE =~ s/wit$/lck/;
if ( $LOCKFILE =~ /$LOGFILE/ )
{
	exit;
}
if ( -e $LOCKFILE )
{
	if ( 0 == fork() )
	{
		sleep(5);
		exit;
	}
	else
	{
		wait();
	}
	unlink $LOCKFILE;
}
open(LFILE ,">$LOCKFILE");
close(LFILE);
# Write to Access Log File
open(FILE ,">>$LOGFILE");
print FILE $rec;
close(FILE);

# Create Access Count File
$cnt = 0;
open(FILE ,"<$LOGFILE");
while (<FILE>)
{
	if ( 0 == index($_,'{+}') )
	{
		$cnt++;
	}
}
close(FILE);
$CNTFILE = $LOGFILE;
$CNTFILE =~ s/wit$/cnt/;
if ( $CNTFILE =~ /$LOGFILE/ )
{
	exit;
}
open(CFILE ,">$CNTFILE");
print CFILE $cnt;
close(CFILE);
unlink $LOCKFILE;
